﻿/*********************************************************************
 * The MIT License (MIT)
 * 
 * Copyright (c) 2010 Manish Sinha <mail@manishsinha.net>
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:

 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 ********************************************************************/


using System;

namespace LpNet.WadlSharp.Common.Interface.Generator
{
    using System.CodeDom;
    using Resources;
    using System.Collections.Generic;

    public interface IClass
    {
        /// <summary>
        /// Create a CodeDeclarationType (Class)
        /// </summary>
        /// <param name="repType">The representation instance which has non-null params Property</param>
        /// <param name="nameSpaces">The list of namespaces import required in the final generated code</param>
        /// <param name="ns">The root namespace for all the generated Types</param>
        /// <returns>Instance of CodeTypeDeclaration</returns>
        CodeTypeDeclaration Create(representation_type repType, HashSet<string> nameSpaces, CodeNamespace ns);

        CodeTypeDeclaration Create(resource_type resourceType, HashSet<string> nameSpaces, CodeNamespace ns);
    }
}
