﻿/*********************************************************************
 * The MIT License (MIT)
 * 
 * Copyright (c) 2010 Manish Sinha <mail@manishsinha.net>
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:

 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 ********************************************************************/




namespace LpNet.WadlSharp.Common
{
    using System.Text.RegularExpressions;
    using Enum;

    public class WadlSharpUtils
    {
        public static string CreateIdentifier(string methodCandidate)
        {
            string filteredString = methodCandidate.Replace("-", "_");
            filteredString = filteredString.Replace(".", "_");
            filteredString = filteredString.Replace(" ", "_");

            return filteredString;
        }

        public static string FilterComments(string commentString)
        {
            string filteredText = commentString.Replace("\n", "");
            Regex rgx = new Regex(@"\s+");
            filteredText = rgx.Replace(filteredText, " ").Trim();

            return filteredText;
        }

        public static string CreateParameter(string parameterName)
        {
            string filteredString = parameterName.Replace("-", "_");
            filteredString = filteredString.Replace(".", "_");

            return filteredString;
        }

        public static string CreateAnchor(string url)
        {
            int hashPos = url.IndexOf('#');

            if (hashPos != -1)
            {
                string href = url.Substring(hashPos + 1);
                return href;
            }
            else
            {
                return url;
            }
        }

        public static HttpMethodType ParseHttpMethod(string methodName)
        {
            HttpMethodType method = (HttpMethodType)System.Enum.Parse(typeof (HttpMethodType), methodName);

            return method;
        }
    }
}
